<html>
<head>
<title>Ogre::SharedPtr&lt; T &gt; Class Template Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::SharedPtr&lt; T &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::SharedPtr" -->
<p>Reference-counted shared pointer, used for objects where implicit destruction is required.  
 <a href="classOgre_1_1SharedPtr.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>&gt;</code></p>

<p><a href="classOgre_1_1SharedPtr-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="OgreThreadDefinesTBB_8h.html#ab0e8c6d123555d7447c38185a1b9105e">OGRE_AUTO_SHARED_MUTEX</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#ae46c7b984c057d18d8bd169cf2a60fad">SharedPtr</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor, does not initialise the <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>.  <a href="#ae46c7b984c057d18d8bd169cf2a60fad"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;class Y &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a9daf742e1f2c363bdcaccff255f2dd2d">SharedPtr</a> (Y *rep, <a class="el" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a">SharedPtrFreeMethod</a> inFreeMethod=<a class="el" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd">SPFM_DELETE</a>)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a9daf742e1f2c363bdcaccff255f2dd2d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#ab1fae2b13ec9cb470b4616c56cb599d8">SharedPtr</a> (const <a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a> &amp;r)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a1ce00b90526a205ae31268a88bc9ed35">operator=</a> (const <a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a> &amp;r)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;class Y &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#ad9ac8d216452366004f13221074ea906">SharedPtr</a> (const <a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&lt; Y &gt; &amp;r)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;class Y &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a> &amp;&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a291dacc84f7f971399a37f725003e9df">operator=</a> (const <a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&lt; Y &gt; &amp;r)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a3677e6904cd453e75b9b352ffe32f99d">~SharedPtr</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a6c7563f3047bcd454dffae2b297a87a1">operator*</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a756cec152c2db605fe7424da7f8e879b">operator-&gt;</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a2c3ed4a7b5574c4e53adec450fd537b0">get</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#ac8d90e023455dc3299f48722e6068e4a">bind</a> (T *rep, <a class="el" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a">SharedPtrFreeMethod</a> inFreeMethod=<a class="el" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd">SPFM_DELETE</a>)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Binds rep to the <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>.  <a href="#ac8d90e023455dc3299f48722e6068e4a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#acd2b97578b72dd4abc33471a93ca4b91">unique</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a29e90ed7b4339cce1cc7e6be919e78bb">useCount</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a">SharedPtrFreeMethod</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a2d8365d61e610b98e0d36d514ab29017">freeMethod</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a> (void) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#ae23c79e49621afdb17fc32f30519859f">setNull</a> (void)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#aa9225d4dac90501b6a5f0b2b49ea2eed">release</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#afaba3332d99634ccbacef674fc46b773">destroy</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">swap</a> (<a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&lt; T &gt; &amp;other)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a">SharedPtrFreeMethod</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><h3>template&lt;class T&gt;<br/>
class Ogre::SharedPtr&lt; T &gt;</h3>

<p>Reference-counted shared pointer, used for objects where implicit destruction is required. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is a standard shared pointer implementation which uses a reference count to work out when to delete the object. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>If OGRE_THREAD_SUPPORT is defined to be 1, use of this class is thread-safe. </dd></dl>

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00060">60</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ae46c7b984c057d18d8bd169cf2a60fad"></a><!-- doxytag: member="Ogre::SharedPtr::SharedPtr" ref="ae46c7b984c057d18d8bd169cf2a60fad" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="OgreThreadDefinesTBB_8h.html#ab0e8c6d123555d7447c38185a1b9105e">OGRE_AUTO_SHARED_MUTEX</a> <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Constructor, does not initialise the <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd><b>Dangerous!</b> You have to call <a class="el" href="classOgre_1_1SharedPtr.html#ac8d90e023455dc3299f48722e6068e4a" title="Binds rep to the SharedPtr.">bind()</a> before using the <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00072">72</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9daf742e1f2c363bdcaccff255f2dd2d"></a><!-- doxytag: member="Ogre::SharedPtr::SharedPtr" ref="a9daf742e1f2c363bdcaccff255f2dd2d" args="(Y *rep, SharedPtrFreeMethod inFreeMethod=SPFM_DELETE)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<div class="memtemplate">
template&lt;class Y &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a> </td>
          <td>(</td>
          <td class="paramtype">Y *&#160;</td>
          <td class="paramname"><em>rep</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a">SharedPtrFreeMethod</a>&#160;</td>
          <td class="paramname"><em>inFreeMethod</em> = <code><a class="el" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd">SPFM_DELETE</a></code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [explicit]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Constructor. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">rep</td><td>The pointer to take ownership of </td></tr>
    <tr><td class="paramname">freeMode</td><td>The mechanism to use to free the pointer </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00082">82</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab1fae2b13ec9cb470b4616c56cb599d8"></a><!-- doxytag: member="Ogre::SharedPtr::SharedPtr" ref="ab1fae2b13ec9cb470b4616c56cb599d8" args="(const SharedPtr &amp;r)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>r</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00093">93</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad9ac8d216452366004f13221074ea906"></a><!-- doxytag: member="Ogre::SharedPtr::SharedPtr" ref="ad9ac8d216452366004f13221074ea906" args="(const SharedPtr&lt; Y &gt; &amp;r)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<div class="memtemplate">
template&lt;class Y &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&lt; Y &gt; &amp;&#160;</td>
          <td class="paramname"><em>r</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00124">124</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3677e6904cd453e75b9b352ffe32f99d"></a><!-- doxytag: member="Ogre::SharedPtr::~SharedPtr" ref="a3677e6904cd453e75b9b352ffe32f99d" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::~<a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00154">154</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ac8d90e023455dc3299f48722e6068e4a"></a><!-- doxytag: member="Ogre::SharedPtr::bind" ref="ac8d90e023455dc3299f48722e6068e4a" args="(T *rep, SharedPtrFreeMethod inFreeMethod=SPFM_DELETE)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#ac8d90e023455dc3299f48722e6068e4a">bind</a> </td>
          <td>(</td>
          <td class="paramtype">T *&#160;</td>
          <td class="paramname"><em>rep</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a">SharedPtrFreeMethod</a>&#160;</td>
          <td class="paramname"><em>inFreeMethod</em> = <code><a class="el" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd">SPFM_DELETE</a></code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Binds rep to the <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Assumes that the <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a> is uninitialised! </dd></dl>

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00167">167</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="afaba3332d99634ccbacef674fc46b773"></a><!-- doxytag: member="Ogre::SharedPtr::destroy" ref="afaba3332d99634ccbacef674fc46b773" args="(void)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#afaba3332d99634ccbacef674fc46b773">destroy</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented in <a class="el" href="classOgre_1_1MeshPtr.html#ac3c7d33a2533d416826dbcebbc7a238e">Ogre::MeshPtr</a>.</p>

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00223">223</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSharedPtr_8h_source.html#l00197">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::release()</a>.</p>

</div>
</div>
<a class="anchor" id="a2d8365d61e610b98e0d36d514ab29017"></a><!-- doxytag: member="Ogre::SharedPtr::freeMethod" ref="a2d8365d61e610b98e0d36d514ab29017" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a">SharedPtrFreeMethod</a> <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#a2d8365d61e610b98e0d36d514ab29017">freeMethod</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00181">181</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSharedPtr_8h_source.html#l00124">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::SharedPtr()</a>.</p>

</div>
</div>
<a class="anchor" id="a2c3ed4a7b5574c4e53adec450fd537b0"></a><!-- doxytag: member="Ogre::SharedPtr::get" ref="a2c3ed4a7b5574c4e53adec450fd537b0" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#a2c3ed4a7b5574c4e53adec450fd537b0">get</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00161">161</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSharedPtr_8h_source.html#l00263">Ogre::operator!=()</a>, and <a class="el" href="OgreSharedPtr_8h_source.html#l00258">Ogre::operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a15e055008751a7c20bdde38662d5f0a1"></a><!-- doxytag: member="Ogre::SharedPtr::getPointer" ref="a15e055008751a7c20bdde38662d5f0a1" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00180">180</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreCompositor_8h_source.html#l00188">Ogre::CompositorPtr::CompositorPtr()</a>, <a class="el" href="OgreD3D11GpuProgram_8h_source.html#l00102">Ogre::D3D11GpuProgramPtr::D3D11GpuProgramPtr()</a>, <a class="el" href="OgreD3D11Texture_8h_source.html#l00187">Ogre::D3D11TexturePtr::D3D11TexturePtr()</a>, <a class="el" href="OgreD3D9GpuProgram_8h_source.html#l00179">Ogre::D3D9GpuProgramPtr::D3D9GpuProgramPtr()</a>, <a class="el" href="OgreD3D9Texture_8h_source.html#l00233">Ogre::D3D9TexturePtr::D3D9TexturePtr()</a>, <a class="el" href="OgreFont_8h_source.html#l00431">Ogre::FontPtr::FontPtr()</a>, <a class="el" href="OgreGLES2Texture_8h_source.html#l00114">Ogre::GLES2TexturePtr::GLES2TexturePtr()</a>, <a class="el" href="OgreGLESTexture_8h_source.html#l00114">Ogre::GLESTexturePtr::GLESTexturePtr()</a>, <a class="el" href="OgreGLTexture_8h_source.html#l00116">Ogre::GLTexturePtr::GLTexturePtr()</a>, <a class="el" href="OgreGpuProgram_8h_source.html#l00438">Ogre::GpuProgramPtr::GpuProgramPtr()</a>, <a class="el" href="OgreHighLevelGpuProgram_8h_source.html#l00145">Ogre::HighLevelGpuProgramPtr::HighLevelGpuProgramPtr()</a>, <a class="el" href="OgreMaterial_8h_source.html#l00693">Ogre::MaterialPtr::MaterialPtr()</a>, <a class="el" href="OgrePatchMesh_8h_source.html#l00112">Ogre::PatchMeshPtr::operator=()</a>, <a class="el" href="OgreD3D11GpuProgram_8h_source.html#l00116">Ogre::D3D11GpuProgramPtr::operator=()</a>, <a class="el" href="OgreGLESTexture_8h_source.html#l00136">Ogre::GLESTexturePtr::operator=()</a>, <a class="el" href="OgreGLES2Texture_8h_source.html#l00136">Ogre::GLES2TexturePtr::operator=()</a>, <a class="el" href="OgreGLTexture_8h_source.html#l00137">Ogre::GLTexturePtr::operator=()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00145">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::operator=()</a>, <a class="el" href="OgreHighLevelGpuProgram_8h_source.html#l00162">Ogre::HighLevelGpuProgramPtr::operator=()</a>, <a class="el" href="OgreD3D9GpuProgram_8h_source.html#l00193">Ogre::D3D9GpuProgramPtr::operator=()</a>, <a class="el" href="OgreD3D11Texture_8h_source.html#l00204">Ogre::D3D11TexturePtr::operator=()</a>, <a class="el" href="OgreCompositor_8h_source.html#l00205">Ogre::CompositorPtr::operator=()</a>, <a class="el" href="OgreD3D9Texture_8h_source.html#l00254">Ogre::D3D9TexturePtr::operator=()</a>, <a class="el" href="OgreFont_8h_source.html#l00448">Ogre::FontPtr::operator=()</a>, <a class="el" href="OgreGpuProgram_8h_source.html#l00455">Ogre::GpuProgramPtr::operator=()</a>, <a class="el" href="OgreTexture_8h_source.html#l00465">Ogre::TexturePtr::operator=()</a>, <a class="el" href="OgreSkeleton_8h_source.html#l00493">Ogre::SkeletonPtr::operator=()</a>, <a class="el" href="OgreMaterial_8h_source.html#l00710">Ogre::MaterialPtr::operator=()</a>, <a class="el" href="OgrePatchMesh_8h_source.html#l00095">Ogre::PatchMeshPtr::PatchMeshPtr()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00124">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::SharedPtr()</a>, <a class="el" href="OgreSkeleton_8h_source.html#l00476">Ogre::SkeletonPtr::SkeletonPtr()</a>, and <a class="el" href="OgreTexture_8h_source.html#l00448">Ogre::TexturePtr::TexturePtr()</a>.</p>

</div>
</div>
<a class="anchor" id="a8a223db784efd7aa766792649de2f2a0"></a><!-- doxytag: member="Ogre::SharedPtr::isNull" ref="a8a223db784efd7aa766792649de2f2a0" args="(void) const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00183">183</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgrePatchMesh_8h_source.html#l00112">Ogre::PatchMeshPtr::operator=()</a>, <a class="el" href="OgreGLES2Texture_8h_source.html#l00136">Ogre::GLES2TexturePtr::operator=()</a>, <a class="el" href="OgreGLESTexture_8h_source.html#l00136">Ogre::GLESTexturePtr::operator=()</a>, <a class="el" href="OgreGLTexture_8h_source.html#l00137">Ogre::GLTexturePtr::operator=()</a>, <a class="el" href="OgreHighLevelGpuProgram_8h_source.html#l00162">Ogre::HighLevelGpuProgramPtr::operator=()</a>, <a class="el" href="OgreCompositor_8h_source.html#l00205">Ogre::CompositorPtr::operator=()</a>, <a class="el" href="OgreD3D9Texture_8h_source.html#l00254">Ogre::D3D9TexturePtr::operator=()</a>, <a class="el" href="OgreFont_8h_source.html#l00448">Ogre::FontPtr::operator=()</a>, <a class="el" href="OgreGpuProgram_8h_source.html#l00455">Ogre::GpuProgramPtr::operator=()</a>, <a class="el" href="OgreTexture_8h_source.html#l00465">Ogre::TexturePtr::operator=()</a>, <a class="el" href="OgreSkeleton_8h_source.html#l00493">Ogre::SkeletonPtr::operator=()</a>, and <a class="el" href="OgreMaterial_8h_source.html#l00710">Ogre::MaterialPtr::operator=()</a>.</p>

</div>
</div>
<a class="anchor" id="a6c7563f3047bcd454dffae2b297a87a1"></a><!-- doxytag: member="Ogre::SharedPtr::operator*" ref="a6c7563f3047bcd454dffae2b297a87a1" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T&amp; <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::operator* </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00159">159</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="a756cec152c2db605fe7424da7f8e879b"></a><!-- doxytag: member="Ogre::SharedPtr::operator&#45;&gt;" ref="a756cec152c2db605fe7424da7f8e879b" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::operator-&gt; </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00160">160</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1ce00b90526a205ae31268a88bc9ed35"></a><!-- doxytag: member="Ogre::SharedPtr::operator=" ref="a1ce00b90526a205ae31268a88bc9ed35" args="(const SharedPtr &amp;r)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&amp; <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>r</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00113">113</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="a291dacc84f7f971399a37f725003e9df"></a><!-- doxytag: member="Ogre::SharedPtr::operator=" ref="a291dacc84f7f971399a37f725003e9df" args="(const SharedPtr&lt; Y &gt; &amp;r)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<div class="memtemplate">
template&lt;class Y &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&amp; <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&lt; Y &gt; &amp;&#160;</td>
          <td class="paramname"><em>r</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00145">145</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa9225d4dac90501b6a5f0b2b49ea2eed"></a><!-- doxytag: member="Ogre::SharedPtr::release" ref="aa9225d4dac90501b6a5f0b2b49ea2eed" args="(void)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#aa9225d4dac90501b6a5f0b2b49ea2eed">release</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00197">197</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSharedPtr_8h_source.html#l00185">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::setNull()</a>, and <a class="el" href="OgreSharedPtr_8h_source.html#l00154">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::~SharedPtr()</a>.</p>

</div>
</div>
<a class="anchor" id="ae23c79e49621afdb17fc32f30519859f"></a><!-- doxytag: member="Ogre::SharedPtr::setNull" ref="ae23c79e49621afdb17fc32f30519859f" args="(void)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#ae23c79e49621afdb17fc32f30519859f">setNull</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00185">185</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="af07cad7e719e517472410d87f4e974ea"></a><!-- doxytag: member="Ogre::SharedPtr::swap" ref="af07cad7e719e517472410d87f4e974ea" args="(SharedPtr&lt; T &gt; &amp;other)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">swap</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SharedPtr.html">SharedPtr</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00247">247</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSharedPtr_8h_source.html#l00113">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::operator=()</a>, and <a class="el" href="OgreSharedPtr_8h_source.html#l00247">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::swap()</a>.</p>

</div>
</div>
<a class="anchor" id="acd2b97578b72dd4abc33471a93ca4b91"></a><!-- doxytag: member="Ogre::SharedPtr::unique" ref="acd2b97578b72dd4abc33471a93ca4b91" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#acd2b97578b72dd4abc33471a93ca4b91">unique</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00176">176</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="a29e90ed7b4339cce1cc7e6be919e78bb"></a><!-- doxytag: member="Ogre::SharedPtr::useCount" ref="a29e90ed7b4339cce1cc7e6be919e78bb" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#a29e90ed7b4339cce1cc7e6be919e78bb">useCount</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00177">177</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

</div>
</div>
<a class="anchor" id="a21c3410c03ec3a4647c7aaa8e59d535d"></a><!-- doxytag: member="Ogre::SharedPtr::useCountPointer" ref="a21c3410c03ec3a4647c7aaa8e59d535d" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">unsigned int* <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00178">178</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreCompositor_8h_source.html#l00188">Ogre::CompositorPtr::CompositorPtr()</a>, <a class="el" href="OgreD3D11GpuProgram_8h_source.html#l00102">Ogre::D3D11GpuProgramPtr::D3D11GpuProgramPtr()</a>, <a class="el" href="OgreD3D11Texture_8h_source.html#l00187">Ogre::D3D11TexturePtr::D3D11TexturePtr()</a>, <a class="el" href="OgreD3D9GpuProgram_8h_source.html#l00179">Ogre::D3D9GpuProgramPtr::D3D9GpuProgramPtr()</a>, <a class="el" href="OgreD3D9Texture_8h_source.html#l00233">Ogre::D3D9TexturePtr::D3D9TexturePtr()</a>, <a class="el" href="OgreFont_8h_source.html#l00431">Ogre::FontPtr::FontPtr()</a>, <a class="el" href="OgreGLES2Texture_8h_source.html#l00114">Ogre::GLES2TexturePtr::GLES2TexturePtr()</a>, <a class="el" href="OgreGLESTexture_8h_source.html#l00114">Ogre::GLESTexturePtr::GLESTexturePtr()</a>, <a class="el" href="OgreGLTexture_8h_source.html#l00116">Ogre::GLTexturePtr::GLTexturePtr()</a>, <a class="el" href="OgreGpuProgram_8h_source.html#l00438">Ogre::GpuProgramPtr::GpuProgramPtr()</a>, <a class="el" href="OgreHighLevelGpuProgram_8h_source.html#l00145">Ogre::HighLevelGpuProgramPtr::HighLevelGpuProgramPtr()</a>, <a class="el" href="OgreMaterial_8h_source.html#l00693">Ogre::MaterialPtr::MaterialPtr()</a>, <a class="el" href="OgrePatchMesh_8h_source.html#l00112">Ogre::PatchMeshPtr::operator=()</a>, <a class="el" href="OgreD3D11GpuProgram_8h_source.html#l00116">Ogre::D3D11GpuProgramPtr::operator=()</a>, <a class="el" href="OgreGLESTexture_8h_source.html#l00136">Ogre::GLESTexturePtr::operator=()</a>, <a class="el" href="OgreGLES2Texture_8h_source.html#l00136">Ogre::GLES2TexturePtr::operator=()</a>, <a class="el" href="OgreGLTexture_8h_source.html#l00137">Ogre::GLTexturePtr::operator=()</a>, <a class="el" href="OgreHighLevelGpuProgram_8h_source.html#l00162">Ogre::HighLevelGpuProgramPtr::operator=()</a>, <a class="el" href="OgreD3D9GpuProgram_8h_source.html#l00193">Ogre::D3D9GpuProgramPtr::operator=()</a>, <a class="el" href="OgreD3D11Texture_8h_source.html#l00204">Ogre::D3D11TexturePtr::operator=()</a>, <a class="el" href="OgreCompositor_8h_source.html#l00205">Ogre::CompositorPtr::operator=()</a>, <a class="el" href="OgreD3D9Texture_8h_source.html#l00254">Ogre::D3D9TexturePtr::operator=()</a>, <a class="el" href="OgreFont_8h_source.html#l00448">Ogre::FontPtr::operator=()</a>, <a class="el" href="OgreGpuProgram_8h_source.html#l00455">Ogre::GpuProgramPtr::operator=()</a>, <a class="el" href="OgreTexture_8h_source.html#l00465">Ogre::TexturePtr::operator=()</a>, <a class="el" href="OgreSkeleton_8h_source.html#l00493">Ogre::SkeletonPtr::operator=()</a>, <a class="el" href="OgreMaterial_8h_source.html#l00710">Ogre::MaterialPtr::operator=()</a>, <a class="el" href="OgrePatchMesh_8h_source.html#l00095">Ogre::PatchMeshPtr::PatchMeshPtr()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00124">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::SharedPtr()</a>, <a class="el" href="OgreSkeleton_8h_source.html#l00476">Ogre::SkeletonPtr::SkeletonPtr()</a>, and <a class="el" href="OgreTexture_8h_source.html#l00448">Ogre::TexturePtr::TexturePtr()</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a8a5094cabd90223647525fe162e94e57"></a><!-- doxytag: member="Ogre::SharedPtr::pRep" ref="a8a5094cabd90223647525fe162e94e57" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00063">63</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSharedPtr_8h_source.html#l00167">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::bind()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00223">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::destroy()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00161">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::get()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00180">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::getPointer()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00183">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::isNull()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00159">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::operator*()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00160">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::operator-&gt;()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00113">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::operator=()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00185">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::setNull()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00093">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::SharedPtr()</a>, and <a class="el" href="OgreSharedPtr_8h_source.html#l00247">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::swap()</a>.</p>

</div>
</div>
<a class="anchor" id="a52f9915e259723090662cca7c3c51d52"></a><!-- doxytag: member="Ogre::SharedPtr::pUseCount" ref="a52f9915e259723090662cca7c3c51d52" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">unsigned int* <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00064">64</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSharedPtr_8h_source.html#l00167">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::bind()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00223">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::destroy()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00197">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::release()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00185">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::setNull()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00093">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::SharedPtr()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00247">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::swap()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00176">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::unique()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00177">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::useCount()</a>, and <a class="el" href="OgreSharedPtr_8h_source.html#l00178">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::useCountPointer()</a>.</p>

</div>
</div>
<a class="anchor" id="a81eed90dd7d087f03cd010167d91f33e"></a><!-- doxytag: member="Ogre::SharedPtr::useFreeMethod" ref="a81eed90dd7d087f03cd010167d91f33e" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a">SharedPtrFreeMethod</a> <a class="el" href="classOgre_1_1SharedPtr.html">Ogre::SharedPtr</a>&lt; T &gt;::<a class="el" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSharedPtr_8h_source.html#l00065">65</a> of file <a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSharedPtr_8h_source.html#l00167">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::bind()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00223">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::destroy()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00181">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::freeMethod()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00093">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::SharedPtr()</a>, and <a class="el" href="OgreSharedPtr_8h_source.html#l00247">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::swap()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:07
</p>
</body>
</html>
